Bug 250921 - Add a config option for ifup-ipv6 to prefer autoconfigured IPv6 addresses to manually-assigned ones
Add a config option for ifup-ipv6 to prefer autoconfigured IPv6 addresses to ...
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: initscripts (Show other bugs)
13
All Linux
low Severity low
: ---
: ---
Assigned To: Bill Nottingham
Fedora Extras Quality Assurance
bzcl34nup
: FutureFeature, Reopened, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-08-05 05:09 EDT by Russell Odom
Modified: 2014-03-16 23:07 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-06-27 09:54:58 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Bugzilla 250919 None None None Never

  None (edit)
Description Russell Odom 2007-08-05 05:09:04 EDT
Description of problem:
Would like a setting in /etc/sysconfig/networking/devices/ifcfg-eth0 to prefer
using of auto-configured IPv6 addresses over any set with IPV6ADDR and
IPV6ADDR_SECONDARIES for outgoing connections - perhaps
"IPV6_AUTOCONF_PREFER=yes" or similar.

RFC 3041 section 2.4 describes why one might want to do this:
> Many machines function as both clients and servers.  In such cases,
> the machine would need a DNS name for its use as a server.  Whether
> the address stays fixed or changes has little privacy implication
> since the DNS name remains constant and serves as a constant
> identifier.  When acting as a client (e.g., initiating
> communication), however, such a machine may want to vary the
> addresses it uses.  In such environments, one may need multiple
> addresses: a "public" (i.e., non-secret) server address, registered
> in the DNS, that is used to accept incoming connection requests from
> other machines, and a "temporary" address used to shield the identity
> of the client when it initiates communication.  These two cases are
> roughly analogous to telephone numbers and caller ID, where a user
> may list their telephone number in the public phone book, but disable
> the display of its number via caller ID when initiating calls.

I've done a bit of hacking around and it seems that addresses assigned to the
interface earlier are used in preference to addresses assigned later. If I
remove and re-add the public static IP to the interface, the auto-configured
address is then used in preference. The solution therefore might be to change
the order things happen so, if this flag is set, the autoconfiguration is
enabled earlier. however, I can't figure out how to do this, or even if it's
possible :-(

Steps to Reproduce:
1. In /etc/sysconfig/networking/devices/ifcfg-eth0 configure a public IPv6
address in IPV6ADDR or IPV6ADDR_SECONDARIES, and set IPV6_AUTOCONF=yes
2. "service network restart"
2. Visit http://www.whatismyipv6.net/ or similar
  
Actual results:
The IP address found is the manually-configured one.

Expected results:
Would like to see my auto-configured address here.

Additional info:
The underlying privacy issue here will be fully resolved by bug 250919 that I've
just filed, otherwise you still have a predictable, unchanging, public IP.
Comment 1 Peter Bieringer 2007-08-05 08:36:22 EDT
Can you check, whether always the last address in list is used?

Perhaps the problem is related to:
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=199862

BTW: which kernel do you use?
Comment 2 Russell Odom 2007-08-05 12:30:10 EDT
I think it's the address assigned *first* (with the correct scope) that gets
used - but I'm not sure now! I can't see any relationship between the order
they're added and the order they're listed by "ifconfig eth0" either.

I agree, this problem is definitely related to bug 199862; I think combining the
two gives us this order of preference for choosing the outgoing address, which
handles all the scenarios I can think of for making outbound connections from a
specific/random address as desired, without the need for an additional
IPV6_AUTOCONF_PREFER setting as I suggested earlier...

1) The primary address from IPV6ADDR, if the scope is correct
2) An auto-generated address, if one is found with the correct scope
3) An address from IPV6ADDR_SECONDARIES with the correct scope

I think we should duplicate this bug to bug 199862 with a note to that effect -
would you agree?

I am currently running:
Linux detritus.local 2.6.20-1.2948.fc6 #1 SMP Fri Apr 27 19:18:54 EDT 2007
x86_64 x86_64 x86_64 GNU/Linux
Comment 3 Peter Bieringer 2007-08-05 13:53:21 EDT
Yes, this was my same experience. "ip addr add..." adds IPv6 addresses in a for
me strange stack order, means last added one occurs as first one in list and
will be used as default for outgoing connections. Tested on RHEL5 today. So my
note in https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=250921#c1 was a
little bit wrong, the *first* in the "ip addr -6" list is used, usually the last
one in the  IPV6ADDR_SECONDARIES variable.

@Pekka: is there a way to prefer existing addresses? Otherwise we have to detect
&  remove the autogenerated one and add it at last one to become the first in
list again.
Comment 4 Peter Bieringer 2007-08-05 14:42:47 EDT
I tried to extend the scripts, result is: CANTFIX

Reason: mix of autogenerated addresses via receiving router advertisements and
static addresses results in an unpredictable list. It's e.g. not possible to
prefer a manual IPv6 address during interface restart, because RA is received
later resulting in generation of the automatic address.

We can now discuss, whether we should disable accepting router advertisements at
all, if a manual address is given - this can be done by an easy patch (one line):

@@ -251,6 +252,7 @@
 # Setup IPv6 address on specified interface
 if [ -n "$IPV6ADDR" ]; then
        ipv6_add_addr_on_device $DEVICE $IPV6ADDR || exit 1
+       IPV6_AUTOCONF="no"
 fi
 
 # Get current global IPv6 forwarding
Comment 5 Pekka Savola 2007-08-06 01:40:20 EDT
AFAIK, there is no way to prefer one address of an interface over another,
though MIPv6 framework (merged in 2.6.21 or thereabouts) includes a way to do
that, at least partially.  But I don't think it's applicable here.

I suppose IPV6_AUTOCONF could work (provided it will still set a default route
even if no addresses are configured), but that might occur too late in the
process as well -- autoconf on a device would need to be disabled before it's
brought back.
Comment 6 Peter Bieringer 2007-08-06 02:07:30 EDT
@Pekka: regarding your second comment, you're probably right, but should be
solvable, too with a similar solution used for tempaddr toggle (in the pre-step).

I hope, "accept_ra" will only control creation of autoconf address, on at least
2.6.22, following toggles are existing:

net.ipv6.conf.eth0.accept_ra = 1
net.ipv6.conf.eth0.accept_ra_defrtr = 1
net.ipv6.conf.eth0.accept_ra_pinfo = 1
net.ipv6.conf.eth0.accept_ra_rtr_pref = 1
net.ipv6.conf.eth0.accept_ra_rt_info_max_plen = 0
Comment 7 Bug Zapper 2008-04-04 03:30:58 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.
http://fedoraproject.org/wiki/LifeCycle/EOL

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 8 Peter Bieringer 2008-04-04 05:36:47 EDT
Issue still exists on F8 with kernel 2.6.24.3-48.fc8

@Reporter: please update version to 8
Comment 9 Bug Zapper 2008-11-26 02:38:46 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Bug Zapper 2009-11-18 07:21:09 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Pekka Savola 2009-11-24 02:39:47 EST
I think this is still an issue with 12.
Comment 12 Bug Zapper 2010-11-04 08:08:23 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Bug Zapper 2010-12-05 02:15:18 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 14 Russell Odom 2011-01-27 10:45:40 EST
Sorry for delay, confirming this still exists in F13.
Comment 15 Bug Zapper 2011-06-02 14:40:03 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 16 Bug Zapper 2011-06-27 09:54:58 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.